anim8 = require "libraries/anim8/anim8"

function playerload()
  sprite = love.graphics.newImage("assets/turtle_walking2.png")
  g = anim8.newGrid(32, 32, sprite:getWidth(), sprite:getHeight())
    
  player = {
    sprite = sprite,
    x = love.graphics.getWidth() / 2,
    y = love.graphics.getHeight() / 2,
    ox = sprite:getWidth() * .5,
    oy = sprite:getHeight() * .5,
    speed = 100,

    -- animations
    animations = {
      right = anim8.newAnimation(g(1,1, 2,1), 0.2),
      left = anim8.newAnimation(g(1,1, 2,1), 0.2):flipH(),
      idleRight = anim8.newAnimation(g(1,1), 0.2),
      idleLeft = anim8.newAnimation(g(1,1), 0.2):flipH(),
    }
  }
  player.animation = player.animations.idleRight
  
  mouseX = love.mouse.getX()
  mouseLeft = mouseX < love.graphics.getWidth() / 2
  mouseRight = mouseX > love.graphics.getWidth() / 2
end

function playerupdate(dt)
  player.animation:update(dt)
    
  -- keyboard controls
  if love.keyboard.isDown("d") then
    player.x = player.x + (player.speed * dt)
    player.animation = player.animations.right
  end
  if love.keyboard.isDown("a") then
    player.x = player.x - (player.speed * dt)
    player.animation = player.animations.left
  end
  -- mouse / touch controls
  if love.mouse.isDown(1) and mouseRight then
    player.x = player.x + (player.speed * dt)
    player.animation = player.animations.right
  end
  if love.mouse.isDown(1) and mouseLeft then
    player.x = player.x - (player.speed * dt)
    player.animation = player.animations.left
  end
end
-- idle animations
function love.keyreleased(key)
  if key == "d" then
    player.animation = player.animations.idleRight
  end
  if key == "a" then
    player.animation = player.animations.idleLeft
  end
end

function love.mousereleased(x, y, button, istouch)
  if mouseRight == true then
    player.animation = player.animations.idleRight
  end
  if mouseLeft == true then
    player.animation = player.animations.idleLeft
  end
end

function playerdraw()
  player.animation:draw(player.sprite, player.x + player.ox, player.y + player.oy, 0, 2, 2, player.ox, player.oy)
end